Index: palm/trunk/TESTS/cases/cbl_particle_nested/MONITORING/cbl_particle_nested_rc
===================================================================
--- palm/trunk/TESTS/cases/cbl_particle_nested/MONITORING/cbl_particle_nested_rc	(revision 4215)
+++ palm/trunk/TESTS/cases/cbl_particle_nested/MONITORING/cbl_particle_nested_rc	(revision 4327)
@@ -1,9 +1,9 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 3915M       *    atmosphere - nested run without 1D - prerun
+ * PALM 6.0  Rev: 4325M       *    atmosphere - nested run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2019-09-03    Run:       cbl_particle_nested__gfortran_defa
- Time:                 15:05:05    Run-No.:   00
+ Date:               2019-12-06    Run:       cbl_particle_nested__gfortran_defa
+ Time:                 11:03:12    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               2    Processor grid (x,y): (   1,   2) calculated
@@ -180,6 +180,5 @@
                             f*     =  0.000084 1/s
 
-    Day of the year at model start :   day_init      =     172
-    UTC time at model start        :   time_utc_init = 43200.0 s
+    Date and time at model start : 2019-06-21 12:00:00 +00
 
     Gravity             :   g      =  9.8 m/s**2
@@ -252,39 +251,39 @@
 ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   0      0 00:00:00.00  18.9000A   1.1899D  1.2022D  0.1180  0.000  1.40   0.000E+00    800.  0.953E+00  0.103E-02  0.628E-03  0.725E-06    9   9  23    4   5  25    5  26   7    0.000    0.000       2
-  0      1 00:00:18.90   0.3520A -33.4068 -31.9721   6.8873  0.165  0.00  -0.858E+00      0.  0.194E+01  0.553E+00  0.155E-02  0.143E-04    2  20  16    2  16  20    4  15  20    0.000    0.000       2
-  0      2 00:00:19.25   0.5030A  20.8646  21.2188  -5.0981  0.120  1.34  -0.112E+01    700.  0.146E+01  0.238E+00  0.306E-03  0.101E-04    2  15  21    2  21  15    4  16  21    0.000    0.000       2
-  0      3 00:00:19.75   0.5570A  16.5227  16.6816  -5.3953  0.074  0.56  -0.184E+01     50.  0.114E+01  0.868E-01  0.242E-03  0.383E-05    2  15  21    2  21  15    4  16  21    0.000    0.000       2
-  0      4 00:00:20.31   0.7190A  14.3325  14.4750  -5.4343  0.054  0.70  -0.270E+01    100.  0.106E+01  0.545E-01  0.127E-03  0.265E-05    2  15  21    2  21  15    4  16  21    0.000    0.000       2
-  0      5 00:00:21.03   0.8020A  14.0259  14.3006   5.3372  0.045  0.00  -0.325E+01      0.  0.104E+01  0.463E-01  0.748E-04  0.412E-06    2  15  21    2  21  15    1  20  15    0.000    0.000       2
-  0      6 00:00:21.83   0.8380A  14.5397  14.9663  -5.6421  0.042  0.00  -0.360E+01      0.  0.103E+01  0.449E-01  0.481E-04  0.107E-05    2  15  21    2  21  15    4  20  15    0.000    0.000       2
-  0      7 00:00:22.67   0.9250A  14.7095  15.4064  -5.2995  0.041  1.40  -0.380E+01    800.  0.103E+01  0.447E-01  0.360E-04  0.101E-05    2  15  21    3  21  15    4  20  15    0.000    0.000       2
-  0      8 00:00:23.59   1.0500A  14.2401  15.2604  -4.6479  0.040  0.56  -0.387E+01     50.  0.102E+01  0.439E-01  0.296E-04  0.212E-06    2  15  21    3  21  15    4  20  15    0.000    0.000       2
-  0      9 00:00:24.64   1.2200A  13.1951  14.2037  -4.8104  0.040  0.56  -0.386E+01     50.  0.102E+01  0.419E-01  0.286E-04  0.462E-06    2  15  21    3  21  15    3  16  20    0.000    0.000       2
-  0     10 00:00:25.86   1.4200A  11.7397  12.3688  -4.9549  0.040  0.70  -0.381E+01    100.  0.102E+01  0.390E-01  0.309E-04  0.559E-06    2  15  21    3  21  15    3  16  20    0.000    0.000       2
-  0     11 00:00:27.28   1.5600A   9.9945  10.1370  -4.8985  0.040  0.00  -0.372E+01      0.  0.102E+01  0.360E-01  0.332E-04  0.218E-06    2  15  21    2  21  15    3  16  20    0.000    0.000       2
-  0     12 00:00:28.84   1.6800A   8.1141   9.5274  -5.0693  0.041  0.00  -0.361E+01      0.  0.101E+01  0.334E-01  0.343E-04  0.153E-06    2  15  21    3  22  15    3  21  14    0.000    0.000       2
-  0     13 00:00:30.52   1.7500A   8.5554   9.4112  -5.8314  0.041  0.00  -0.350E+01      0.  0.101E+01  0.313E-01  0.356E-04  0.244E-06    3  15  22    3  22  15    3  21  14    0.000    0.000       2
-  0     14 00:00:32.27   1.8300A   8.3991   8.7179  -5.8863  0.042  0.70  -0.338E+01    100.  0.101E+01  0.296E-01  0.360E-04  0.131E-06    3  15  22    3  22  15    3  21  14    0.000    0.000       2
-  0     15 00:00:34.10   1.9100A   7.8262   7.7828  -5.4088  0.043  0.70  -0.327E+01    100.  0.101E+01  0.283E-01  0.362E-04  0.815E-07    3  15  22    3  22  15    3  21  14    0.000    0.000       2
-  0     16 00:00:36.01   1.9400A   7.0238   7.6143  -4.6348  0.044  0.70  -0.317E+01    100.  0.101E+01  0.274E-01  0.365E-04  0.113E-06    3  15  22    3  23  14    3  21  14    0.000    0.000       2
-  0     17 00:00:37.95   1.9900A   6.6865   7.9022  -3.9049  0.045  0.00  -0.307E+01      0.  0.102E+01  0.269E-01  0.362E-04  0.853E-07    3  14  23    3  23  14    2  17  20    0.000    0.000       2
-  0     18 00:00:39.94   2.0800A   6.8655   7.8003  -3.8046  0.046  0.00  -0.298E+01      0.  0.102E+01  0.265E-01  0.365E-04  0.798E-07    3  14  23    3  23  14    2  17  20    0.000    0.000       2
-  0     19 00:00:42.02   2.1300A   6.7487   7.3887  -3.5926  0.046  0.00  -0.289E+01      0.  0.102E+01  0.262E-01  0.370E-04  0.917E-07    3  14  23    3  23  14    3  22  15    0.000    0.000       2
-  0     20 00:00:44.15   2.2600A   6.4180   6.7884  -3.3730  0.047  0.00  -0.281E+01      0.  0.102E+01  0.260E-01  0.367E-04  0.878E-07    3  14  23    3  23  14    3  22  15    0.000    0.000       2
-  0     21 00:00:46.41   2.3200A   5.9487   6.5635  -3.0799  0.048  0.00  -0.273E+01      0.  0.102E+01  0.257E-01  0.371E-04  0.882E-07    3  14  23    3  24  14    3  15  22    0.000    0.000       2
-  0     22 00:00:48.73   2.4400A   5.6787   6.3292  -2.6936  0.049  0.00  -0.265E+01      0.  0.102E+01  0.255E-01  0.366E-04  0.912E-07    3  14  24    3  24  14    3  22  15    0.000    0.000       2
-  0     23 00:00:51.17   2.5500A   5.4845   5.9633  -2.6051  0.050  0.00  -0.258E+01      0.  0.102E+01  0.253E-01  0.366E-04  0.975E-07    3  14  24    3  24  14    3  23  15    0.000    0.000       2
-  0     24 00:00:53.72   2.7000A   5.2003   5.5430  -2.5986  0.051  0.00  -0.251E+01      0.  0.103E+01  0.252E-01  0.365E-04  0.101E-06    3  14  24    3  24  14    3  23  15    0.000    0.000       2
-  0     25 00:00:56.42   2.8500A   4.8949   5.3920  -2.6670  0.052  0.00  -0.244E+01      0.  0.103E+01  0.250E-01  0.367E-04  0.105E-06    3  14  24    3  25  14    2  16  22    0.000    0.000       2
-  0     26 00:00:59.27   3.0400A   4.5809   5.2786  -2.7760  0.053  1.40  -0.238E+01    800.  0.103E+01  0.248E-01  0.374E-04  0.107E-06    3  14  24    3  25  14    2  16  22    0.000    0.000       2
-  0     27 00:01:02.31   3.2200A   4.4159   5.0462  -2.7142  0.054  1.40  -0.231E+01    800.  0.103E+01  0.247E-01  0.386E-04  0.108E-06    3  14  25    3  25  14    2  16  22    0.000    0.000       2
-  0     28 00:01:05.53   3.4600A   4.4109   4.7549  -2.5336  0.055  1.40  -0.225E+01    800.  0.103E+01  0.246E-01  0.403E-04  0.109E-06    3  14  25    3  25  14    3  21  17    0.000    0.000       2
-  0     29 00:01:08.99   3.6700A   4.3099   4.4345  -2.5000  0.057  1.40  -0.219E+01    800.  0.103E+01  0.245E-01  0.428E-04  0.113E-06    3  14  25    3  25  14    3  21  17    0.000    0.000       2
-  0     30 00:01:12.66   3.9400A   4.1447   4.1854  -2.4769  0.058  1.40  -0.214E+01    800.  0.104E+01  0.244E-01  0.451E-04  0.117E-06    3  14  25    3  26  14    3  21  17    0.000    0.000       2
-  0     31 00:01:16.60   4.2100A   3.9342   4.1081  -2.4728  0.059  1.40  -0.208E+01    800.  0.104E+01  0.243E-01  0.482E-04  0.123E-06    3  14  25    3  26  14    3  21  17    0.000    0.000       2
-  0     32 00:01:20.81   4.4200A   3.8412   3.9700  -2.4695  0.060  1.40  -0.203E+01    800.  0.104E+01  0.242E-01  0.519E-04  0.130E-06    3  13  25    3  26  14    3  21  17    0.000    0.000       2
-  0     33 00:01:25.23   4.5200A   3.7602   3.7944  -2.4356  0.061  1.40  -0.199E+01    800.  0.104E+01  0.241E-01  0.551E-04  0.132E-06    3  13  25    3  26  14    3  21  17    0.000    0.000       2
-  0     34 00:01:29.75   4.6200A   3.6311   3.6103  -2.3584  0.062  1.40  -0.194E+01    800.  0.104E+01  0.240E-01  0.568E-04  0.130E-06    3  13  25    3  26  13    3  21  17    0.000    0.000       2
-  0     35 00:01:34.37   4.7200A   3.4659   3.5850  -2.2681  0.063  1.40  -0.191E+01    800.  0.104E+01  0.239E-01  0.579E-04  0.130E-06    3  13  25    3  26  13    3  17  21    0.000    0.000       2
-  0     36 00:01:39.09   4.9400A   3.4295   3.5202  -2.1981  0.064  1.40  -0.187E+01    800.  0.104E+01  0.238E-01  0.584E-04  0.132E-06    3  13  26    3  26  13    3  17  21    0.000    0.000       2
-  0     37 00:01:44.03   5.1000A   3.3705   3.4219  -2.1245  0.064  1.40  -0.185E+01    800.  0.104E+01  0.237E-01  0.600E-04  0.140E-06    3  13  26    3  26  13    3  17  21    0.000    0.000       2
+  0      1 00:00:18.90   0.3520A -33.4250 -31.9911   6.8868  0.165  0.00  -0.858E+00      0.  0.194E+01  0.553E+00  0.156E-02  0.143E-04    2  20  16    2  16  20    4  15  20    0.000    0.000       2
+  0      2 00:00:19.25   0.5030A  20.8643  21.2183  -5.0981  0.120  1.34  -0.112E+01    700.  0.146E+01  0.238E+00  0.307E-03  0.101E-04    2  15  21    2  21  15    4  16  21    0.000    0.000       2
+  0      3 00:00:19.75   0.5570A  16.5277  16.6867  -5.3950  0.075  0.56  -0.184E+01     50.  0.114E+01  0.868E-01  0.242E-03  0.383E-05    2  15  21    2  21  15    4  16  21    0.000    0.000       2
+  0      4 00:00:20.31   0.7190A  14.3469  14.4897   5.4556  0.054  0.70  -0.271E+01    100.  0.106E+01  0.545E-01  0.127E-03  0.265E-05    2  15  21    2  21  15    1  20  15    0.000    0.000       2
+  0      5 00:00:21.03   0.8020A  14.0461  14.3200   5.4279  0.045  0.00  -0.325E+01      0.  0.104E+01  0.463E-01  0.747E-04  0.412E-06    2  15  21    2  21  15    1  20  15    0.000    0.000       2
+  0      6 00:00:21.83   0.8380A  14.5514  14.9741  -5.6408  0.042  0.00  -0.360E+01      0.  0.103E+01  0.449E-01  0.480E-04  0.107E-05    2  15  21    2  21  15    4  20  15    0.000    0.000       2
+  0      7 00:00:22.67   0.9250A  14.7003  15.4108  -5.2982  0.041  1.40  -0.381E+01    800.  0.103E+01  0.448E-01  0.360E-04  0.101E-05    2  15  21    3  21  15    4  20  15    0.000    0.000       2
+  0      8 00:00:23.59   1.0500A  14.2090  15.2585  -4.6465  0.040  0.56  -0.387E+01     50.  0.102E+01  0.440E-01  0.295E-04  0.212E-06    2  15  21    3  21  15    4  20  15    0.000    0.000       2
+  0      9 00:00:24.64   1.2200A  13.1540  14.1910  -4.7985  0.040  0.56  -0.386E+01     50.  0.102E+01  0.419E-01  0.286E-04  0.462E-06    2  15  21    3  21  15    3  16  20    0.000    0.000       2
+  0     10 00:00:25.86   1.4200A  11.7065  12.3453  -4.9405  0.040  0.70  -0.381E+01    100.  0.102E+01  0.390E-01  0.309E-04  0.559E-06    2  15  21    3  21  15    3  16  20    0.000    0.000       2
+  0     11 00:00:27.28   1.5700A   9.9801  10.1277  -4.8820  0.040  0.00  -0.372E+01      0.  0.102E+01  0.360E-01  0.332E-04  0.217E-06    2  15  21    2  21  15    3  16  20    0.000    0.000       2
+  0     12 00:00:28.85   1.6800A   8.1590   9.5687  -5.0578  0.041  0.00  -0.361E+01      0.  0.101E+01  0.334E-01  0.345E-04  0.155E-06    3  15  22    3  22  15    3  21  14    0.000    0.000       2
+  0     13 00:00:30.53   1.7600A   8.5870   9.4354  -5.8093  0.041  0.00  -0.350E+01      0.  0.101E+01  0.313E-01  0.356E-04  0.243E-06    3  15  22    3  22  15    3  21  14    0.000    0.000       2
+  0     14 00:00:32.29   1.8300A   8.4095   8.7247  -5.8527  0.042  0.70  -0.338E+01    100.  0.101E+01  0.296E-01  0.362E-04  0.130E-06    3  15  22    3  22  15    3  21  14    0.000    0.000       2
+  0     15 00:00:34.12   1.9000A   7.8212   7.7814  -5.3674  0.043  0.70  -0.327E+01    100.  0.101E+01  0.283E-01  0.363E-04  0.815E-07    3  15  22    3  22  15    3  21  14    0.000    0.000       2
+  0     16 00:00:36.02   1.9400A   7.0132   7.7538  -4.5972  0.044  0.70  -0.317E+01    100.  0.101E+01  0.275E-01  0.364E-04  0.113E-06    3  15  22    3  23  14    3  21  14    0.000    0.000       2
+  0     17 00:00:37.96   1.9900A   6.8381   8.0461  -3.8596  0.045  0.00  -0.307E+01      0.  0.102E+01  0.269E-01  0.363E-04  0.849E-07    3  14  23    3  23  14    2  17  20    0.000    0.000       2
+  0     18 00:00:39.95   2.0800A   7.0176   7.9419  -3.7616  0.046  0.00  -0.298E+01      0.  0.102E+01  0.265E-01  0.366E-04  0.799E-07    3  14  23    3  23  14    2  17  20    0.000    0.000       2
+  0     19 00:00:42.03   2.1400A   6.8958   7.5216  -3.5548  0.046  0.00  -0.289E+01      0.  0.102E+01  0.262E-01  0.372E-04  0.919E-07    3  14  23    3  23  14    3  22  15    0.000    0.000       2
+  0     20 00:00:44.17   2.2600A   6.5505   6.8964  -3.3458  0.047  0.00  -0.281E+01      0.  0.102E+01  0.260E-01  0.369E-04  0.884E-07    3  14  23    3  23  14    3  15  22    0.000    0.000       2
+  0     21 00:00:46.43   2.3200A   6.0519   6.6696  -3.0536  0.048  0.00  -0.273E+01      0.  0.102E+01  0.258E-01  0.372E-04  0.881E-07    3  14  23    3  24  14    3  15  22    0.000    0.000       2
+  0     22 00:00:48.75   2.4400A   5.8086   6.4602  -2.6422  0.049  0.00  -0.265E+01      0.  0.102E+01  0.256E-01  0.366E-04  0.913E-07    3  14  24    3  24  14    3  22  15    0.000    0.000       2
+  0     23 00:00:51.19   2.5500A   5.6371   6.1203  -2.5675  0.050  0.00  -0.258E+01      0.  0.102E+01  0.254E-01  0.366E-04  0.973E-07    3  14  24    3  24  14    3  23  15    0.000    0.000       2
+  0     24 00:00:53.74   2.6900A   5.3790   5.7125  -2.5507  0.051  0.00  -0.251E+01      0.  0.103E+01  0.252E-01  0.364E-04  0.101E-06    3  14  24    3  24  14    3  23  15    0.000    0.000       2
+  0     25 00:00:56.43   2.8400A   5.0888   5.5039  -2.6659  0.052  0.00  -0.244E+01      0.  0.103E+01  0.251E-01  0.367E-04  0.105E-06    3  14  24    3  25  14    2  16  22    0.000    0.000       2
+  0     26 00:00:59.27   3.0300A   4.7656   5.3942  -2.7711  0.053  1.40  -0.238E+01    800.  0.103E+01  0.249E-01  0.373E-04  0.106E-06    3  14  24    3  25  14    2  16  22    0.000    0.000       2
+  0     27 00:01:02.30   3.2100A   4.5773   5.1553  -2.7018  0.054  1.40  -0.231E+01    800.  0.103E+01  0.248E-01  0.385E-04  0.108E-06    3  14  25    3  25  14    2  16  22    0.000    0.000       2
+  0     28 00:01:05.51   3.4400A   4.5620   4.8481  -2.5241  0.055  1.40  -0.225E+01    800.  0.103E+01  0.247E-01  0.402E-04  0.109E-06    3  14  25    3  25  14    3  21  17    0.000    0.000       2
+  0     29 00:01:08.95   3.6600A   4.4420   4.5061  -2.4893  0.057  1.40  -0.219E+01    800.  0.103E+01  0.246E-01  0.425E-04  0.113E-06    3  14  25    3  25  14    3  21  17    0.000    0.000       2
+  0     30 00:01:12.61   3.9100A   4.2531   4.2750  -2.4640  0.058  1.40  -0.214E+01    800.  0.104E+01  0.245E-01  0.450E-04  0.117E-06    3  14  25    3  25  13    3  21  17    0.000    0.000       2
+  0     31 00:01:16.52   4.2300A   4.0178   4.1781  -2.4574  0.059  1.40  -0.209E+01    800.  0.104E+01  0.244E-01  0.480E-04  0.122E-06    3  14  25    3  26  14    3  21  17    0.000    0.000       2
+  0     32 00:01:20.75   4.4400A   3.9913   4.0190  -2.4518  0.060  1.40  -0.204E+01    800.  0.104E+01  0.243E-01  0.522E-04  0.131E-06    3  13  25    3  26  14    3  21  17    0.000    0.000       2
+  0     33 00:01:25.19   4.4900A   3.9102   3.8156  -2.4159  0.061  1.40  -0.199E+01    800.  0.104E+01  0.242E-01  0.555E-04  0.133E-06    3  13  25    3  26  14    3  21  17    0.000    0.000       2
+  0     34 00:01:29.68   4.6400A   3.7848   3.7235  -2.3380  0.062  1.40  -0.195E+01    800.  0.104E+01  0.240E-01  0.566E-04  0.129E-06    3  13  25    3  26  13    3  21  17    0.000    0.000       2
+  0     35 00:01:34.32   4.7800A   3.6185   3.6904  -2.2629  0.063  1.40  -0.191E+01    800.  0.104E+01  0.239E-01  0.583E-04  0.132E-06    3  13  25    3  26  13    3  17  21    0.000    0.000       2
+  0     36 00:01:39.10   5.0100A   3.5946   3.6118  -2.1993  0.064  1.40  -0.187E+01    800.  0.104E+01  0.239E-01  0.591E-04  0.135E-06    3  13  26    3  26  13    3  17  21    0.000    0.000       2
+  0     37 00:01:44.11   5.2000A   3.5345   3.4963  -2.1306  0.064  1.40  -0.185E+01    800.  0.104E+01  0.238E-01  0.608E-04  0.143E-06    3  13  26    3  26  13    3  17  21    0.000    0.000       2